package cn.iocoder.yudao.module.pms.service.tdparams;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.module.pms.controller.admin.tdparams.vo.IotTdParamsPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.tdparams.vo.IotTdParamsSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.tdparams.IotTdParamsDO;
import cn.iocoder.yudao.module.pms.dal.mysql.tdparams.IotTdParamsMapper;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 设备模型参数 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotTdParamsServiceImpl implements IotTdParamsService {

    @Resource
    private IotTdParamsMapper iotTdParamsMapper;

    @Override
    public Long createIotTdParams(IotTdParamsSaveReqVO createReqVO) {
        // 插入
        IotTdParamsDO iotTdParams = BeanUtils.toBean(createReqVO, IotTdParamsDO.class);
        iotTdParamsMapper.insert(iotTdParams);
        // 返回
        return iotTdParams.getId();
    }

    @Override
    public void updateIotTdParams(IotTdParamsSaveReqVO updateReqVO) {
        // 校验存在
        validateIotTdParamsExists(updateReqVO.getId());
        // 更新
        IotTdParamsDO updateObj = BeanUtils.toBean(updateReqVO, IotTdParamsDO.class);
        iotTdParamsMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotTdParams(Long id) {
        // 校验存在
        validateIotTdParamsExists(id);
        // 删除
        iotTdParamsMapper.deleteById(id);
    }

    private void validateIotTdParamsExists(Long id) {
        if (iotTdParamsMapper.selectById(id) == null) {
            throw exception(new ErrorCode(333,"不存在模型参数"));
        }
    }

    @Override
    public IotTdParamsDO getIotTdParams(Long id) {
        return iotTdParamsMapper.selectById(id);
    }

    @Override
    public PageResult<IotTdParamsDO> getIotTdParamsPage(IotTdParamsPageReqVO pageReqVO) {
        return iotTdParamsMapper.selectPage(pageReqVO);
    }

}
